Index: src/UIElements/Qt4/Pipe/IntQtQueryPipe.cpp
===================================================================
--- src/UIElements/Qt4/Pipe/IntQtQueryPipe.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/IntQtQueryPipe.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -24,5 +24,5 @@
 
 
-IntQtQueryPipe::IntQtQueryPipe(int *_content, QtDialog *_dialog) :
+IntQtQueryPipe::IntQtQueryPipe(Parameter<int> &_content, QtDialog *_dialog) :
   content(_content),
   dialog(_dialog)
@@ -33,5 +33,5 @@
 
 void IntQtQueryPipe::update(int newInt) {
-  (*content) = newInt;
+  content.set(newInt);
   dialog->update();
 }
Index: src/UIElements/Qt4/Pipe/IntQtQueryPipe.hpp
===================================================================
--- src/UIElements/Qt4/Pipe/IntQtQueryPipe.hpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/IntQtQueryPipe.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -15,4 +15,5 @@
 
 
+#include "Parameters/Parameter.hpp"
 #include <Qt/qwidget.h>
 
@@ -22,5 +23,5 @@
   Q_OBJECT
 public:
-  IntQtQueryPipe(int *_content, QtDialog *_dialog);
+  IntQtQueryPipe(Parameter<int> &_content, QtDialog *_dialog);
   virtual ~IntQtQueryPipe();
 
@@ -29,5 +30,5 @@
 
 private:
-  int *content;
+  Parameter<int> &content;
   QtDialog *dialog;
 
Index: src/UIElements/Qt4/Pipe/MoleculeQtQueryPipe.cpp
===================================================================
--- src/UIElements/Qt4/Pipe/MoleculeQtQueryPipe.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/MoleculeQtQueryPipe.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -29,5 +29,5 @@
 
 
-MoleculeQtQueryPipe::MoleculeQtQueryPipe(const molecule **_content, QtDialog *_dialog, QComboBox *_theBox) :
+MoleculeQtQueryPipe::MoleculeQtQueryPipe(Parameter<const molecule *> &_content, QtDialog *_dialog, QComboBox *_theBox) :
   content(_content),
   dialog(_dialog),
@@ -41,5 +41,5 @@
   QVariant data = theBox->itemData(newIndex);
   int idx = data.toInt();
-  (*content) = World::getInstance().getMolecule(MoleculeById(idx));
+  content.set(World::getInstance().getMolecule(MoleculeById(idx)));
   dialog->update();
 }
Index: src/UIElements/Qt4/Pipe/MoleculeQtQueryPipe.hpp
===================================================================
--- src/UIElements/Qt4/Pipe/MoleculeQtQueryPipe.hpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/MoleculeQtQueryPipe.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -15,4 +15,5 @@
 
 
+#include "Parameters/Parameter.hpp"
 #include <Qt/qwidget.h>
 
@@ -25,5 +26,5 @@
   Q_OBJECT
 public:
-  MoleculeQtQueryPipe(const molecule **_content, QtDialog *_dialog, QComboBox *_theBox);
+  MoleculeQtQueryPipe(Parameter<const molecule *> &_content, QtDialog *_dialog, QComboBox *_theBox);
   virtual ~MoleculeQtQueryPipe();
 
@@ -32,5 +33,5 @@
 
 private:
-  const molecule **content;
+  Parameter<const molecule *> &content;
   QtDialog *dialog;
   QComboBox *theBox;
Index: src/UIElements/Qt4/Pipe/MoleculesQtQueryPipe.cpp
===================================================================
--- src/UIElements/Qt4/Pipe/MoleculesQtQueryPipe.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/MoleculesQtQueryPipe.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -31,5 +31,5 @@
 
 
-MoleculesQtQueryPipe::MoleculesQtQueryPipe(std::vector<const molecule *>*_content, QtDialog *_dialog, QComboBox *_theBox) :
+MoleculesQtQueryPipe::MoleculesQtQueryPipe(Parameter<std::vector<const molecule *> > &_content, QtDialog *_dialog, QComboBox *_theBox) :
   content(_content),
   dialog(_dialog),
@@ -44,6 +44,8 @@
   int idx = data.toInt();
   molecule *mol = World::getInstance().getMolecule(MoleculeById(idx));
+  std::vector<const molecule *> temp_mols;
   if (mol)
-    (*content).push_back(mol);
+    temp_mols.push_back(mol);
+  content.set(temp_mols);
   dialog->update();
 }
Index: src/UIElements/Qt4/Pipe/MoleculesQtQueryPipe.hpp
===================================================================
--- src/UIElements/Qt4/Pipe/MoleculesQtQueryPipe.hpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/MoleculesQtQueryPipe.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -15,4 +15,5 @@
 
 
+#include "Parameters/Parameter.hpp"
 #include <Qt/qwidget.h>
 
@@ -27,5 +28,5 @@
   Q_OBJECT
 public:
-  MoleculesQtQueryPipe(std::vector<const molecule *>*_content, QtDialog *_dialog, QComboBox *_theBox);
+  MoleculesQtQueryPipe(Parameter<std::vector<const molecule *> > &_content, QtDialog *_dialog, QComboBox *_theBox);
   virtual ~MoleculesQtQueryPipe();
 
@@ -34,5 +35,5 @@
 
 private:
-  std::vector<const molecule *>*content;
+  Parameter<std::vector<const molecule *> > &content;
   QtDialog *dialog;
   QComboBox *theBox;
Index: src/UIElements/Qt4/Pipe/QtQueryListPipe.hpp
===================================================================
--- src/UIElements/Qt4/Pipe/QtQueryListPipe.hpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/QtQueryListPipe.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -15,4 +15,5 @@
 
 
+#include "Parameters/Parameter.hpp"
 #include "QtQueryPipe.hpp"
 
@@ -23,5 +24,5 @@
 
 
-template<typename T> QtQueryListPipe<T>::QtQueryListPipe(std::vector<T> *_content, QtDialog *_dialog, QLineEdit *_inputBox, QListWidget *_inputList, QPushButton *_AddButton, QPushButton *_RemoveButton) :
+template<typename T> QtQueryListPipe<T>::QtQueryListPipe(Parameter<std::vector<T> > &_content, QtDialog *_dialog, QLineEdit *_inputBox, QListWidget *_inputList, QPushButton *_AddButton, QPushButton *_RemoveButton) :
   content(_content),
   dialog(_dialog),
Index: src/UIElements/Qt4/Pipe/QtQueryPipe.hpp
===================================================================
--- src/UIElements/Qt4/Pipe/QtQueryPipe.hpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/QtQueryPipe.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -19,4 +19,5 @@
 // since MOC doesn't like nested classes
 
+#include "Parameters/Parameter.hpp"
 #include <Qt/qwidget.h>
 
@@ -33,5 +34,5 @@
 template<typename T> class QtQueryListPipe : public QWidget {
   public:
-    QtQueryListPipe(std::vector<T> *_content, QtDialog *_dialog, QLineEdit *_inputBox, QListWidget *_inputList, QPushButton *_AddButton, QPushButton *_RemoveButton);
+    QtQueryListPipe(Parameter<std::vector<T> > &_content, QtDialog *_dialog, QLineEdit *_inputBox, QListWidget *_inputList, QPushButton *_AddButton, QPushButton *_RemoveButton);
     virtual ~QtQueryListPipe();
     void AddInteger();
@@ -44,5 +45,5 @@
     void RemoveRow(int row);
 
-    std::vector<T> *content;
+    Parameter<std::vector<T> > &content;
     QtDialog *dialog;
     QLineEdit *inputBox;
Index: src/UIElements/Qt4/Pipe/RandomNumberDistribution_ParametersQtQueryPipe.cpp
===================================================================
--- src/UIElements/Qt4/Pipe/RandomNumberDistribution_ParametersQtQueryPipe.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/RandomNumberDistribution_ParametersQtQueryPipe.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -30,5 +30,5 @@
 class RandomNumberDistribution_Parameters;
 
-RandomNumberDistribution_ParametersQtQueryPipe::RandomNumberDistribution_ParametersQtQueryPipe(const RandomNumberDistribution_Parameters *_content, QtDialog *_dialog, QTextEdit *_theBox) :
+RandomNumberDistribution_ParametersQtQueryPipe::RandomNumberDistribution_ParametersQtQueryPipe(Parameter<RandomNumberDistribution_Parameters> &_content, QtDialog *_dialog, QTextEdit *_theBox) :
   content(_content),
   dialog(_dialog),
Index: src/UIElements/Qt4/Pipe/RandomNumberDistribution_ParametersQtQueryPipe.hpp
===================================================================
--- src/UIElements/Qt4/Pipe/RandomNumberDistribution_ParametersQtQueryPipe.hpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/RandomNumberDistribution_ParametersQtQueryPipe.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -15,4 +15,5 @@
 
 
+#include "Parameters/Parameter.hpp"
 #include <Qt/qwidget.h>
 
@@ -25,5 +26,5 @@
   Q_OBJECT
 public:
-  RandomNumberDistribution_ParametersQtQueryPipe(const RandomNumberDistribution_Parameters *_content, QtDialog *_dialog, QTextEdit *_theBox);
+  RandomNumberDistribution_ParametersQtQueryPipe(Parameter<RandomNumberDistribution_Parameters> &_content, QtDialog *_dialog, QTextEdit *_theBox);
   virtual ~RandomNumberDistribution_ParametersQtQueryPipe();
 
@@ -32,5 +33,5 @@
 
 private:
-  const RandomNumberDistribution_Parameters *content;
+  Parameter<RandomNumberDistribution_Parameters> &content;
   QtDialog *dialog;
   QTextEdit *theBox;
Index: src/UIElements/Qt4/Pipe/RealSpaceMatrixQtQueryPipe.cpp
===================================================================
--- src/UIElements/Qt4/Pipe/RealSpaceMatrixQtQueryPipe.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
+++ src/UIElements/Qt4/Pipe/RealSpaceMatrixQtQueryPipe.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -0,0 +1,50 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010-2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * BoxQtQueryPipe.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "UIElements/Qt4/Pipe/RealSpaceMatrixQtQueryPipe.hpp"
+#include "UIElements/Qt4/QtDialog.hpp"
+
+#include <Qt/qcombobox.h>
+#include <Qt/qtablewidget.h>
+
+#include "CodePatterns/MemDebug.hpp"
+#include "LinearAlgebra/RealSpaceMatrix.hpp"
+
+RealSpaceMatrixQtQueryPipe::RealSpaceMatrixQtQueryPipe(Parameter<RealSpaceMatrix> &_content, QtDialog *_dialog, QTableWidget *_inputTable) :
+  content(_content),
+  dialog(_dialog),
+  inputTable(_inputTable)
+{
+  tmpM = new RealSpaceMatrix();
+  tmpM->setIdentity();
+}
+
+RealSpaceMatrixQtQueryPipe::~RealSpaceMatrixQtQueryPipe()
+{
+  delete tmpM;
+}
+
+void RealSpaceMatrixQtQueryPipe::update(int row, int column)
+{
+  tmpM->at(row, column) = inputTable->item(row, column)->text().toDouble();
+  content.set(*tmpM);
+  dialog->update();
+}
+
+
Index: src/UIElements/Qt4/Pipe/RealSpaceMatrixQtQueryPipe.hpp
===================================================================
--- src/UIElements/Qt4/Pipe/RealSpaceMatrixQtQueryPipe.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
+++ src/UIElements/Qt4/Pipe/RealSpaceMatrixQtQueryPipe.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -0,0 +1,44 @@
+/*
+ * BoxQtQueryPipe.hpp
+ *
+ *  Created on: Nov 8, 2010
+ *      Author: heber
+ */
+
+#ifndef BOXQTQUERYPIPE_HPP_
+#define BOXQTQUERYPIPE_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include "Parameters/Parameter.hpp"
+#include <Qt/qwidget.h>
+
+class QTableWidget;
+
+class QtDialog;
+class RealSpaceMatrix;
+
+
+class RealSpaceMatrixQtQueryPipe : public QWidget {
+  Q_OBJECT
+public:
+  RealSpaceMatrixQtQueryPipe(Parameter<RealSpaceMatrix> &_content, QtDialog *_dialog, QTableWidget *_inputTable);
+  virtual ~RealSpaceMatrixQtQueryPipe();
+
+public slots:
+  void update(int,int);
+
+private:
+  Parameter<RealSpaceMatrix> &content;
+  QtDialog *dialog;
+  QTableWidget *inputTable;
+
+  RealSpaceMatrix *tmpM;
+};
+
+
+#endif /* BOXQTQUERYPIPE_HPP_ */
Index: src/UIElements/Qt4/Pipe/StringQtQueryPipe.cpp
===================================================================
--- src/UIElements/Qt4/Pipe/StringQtQueryPipe.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/StringQtQueryPipe.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -26,5 +26,5 @@
 
 
-StringQtQueryPipe::StringQtQueryPipe(std::string *_content, QtDialog *_dialog) :
+StringQtQueryPipe::StringQtQueryPipe(Parameter<std::string> &_content, QtDialog *_dialog) :
   content(_content),
   dialog(_dialog)
@@ -35,5 +35,5 @@
 
 void StringQtQueryPipe::update(const QString& newText) {
-  content->assign(newText.toStdString());
+  content.set(newText.toStdString());
   dialog->update();
 }
Index: src/UIElements/Qt4/Pipe/StringQtQueryPipe.hpp
===================================================================
--- src/UIElements/Qt4/Pipe/StringQtQueryPipe.hpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/StringQtQueryPipe.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -15,4 +15,5 @@
 
 
+#include "Parameters/Parameter.hpp"
 #include <Qt/qwidget.h>
 
@@ -24,5 +25,5 @@
   Q_OBJECT
 public:
-  StringQtQueryPipe(std::string *_content, QtDialog *_dialog);
+  StringQtQueryPipe(Parameter<std::string> &_content, QtDialog *_dialog);
   virtual ~StringQtQueryPipe();
 
@@ -31,5 +32,5 @@
 
 private:
-  std::string *content;
+  Parameter<std::string> &content;
   QtDialog *dialog;
 
Index: src/UIElements/Qt4/Pipe/UnsignedIntQtQueryPipe.cpp
===================================================================
--- src/UIElements/Qt4/Pipe/UnsignedIntQtQueryPipe.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/UnsignedIntQtQueryPipe.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -24,5 +24,5 @@
 
 
-UnsignedIntQtQueryPipe::UnsignedIntQtQueryPipe(unsigned int *_content, QtDialog *_dialog) :
+UnsignedIntQtQueryPipe::UnsignedIntQtQueryPipe(Parameter<unsigned int> &_content, QtDialog *_dialog) :
   content(_content),
   dialog(_dialog)
@@ -33,5 +33,5 @@
 
 void UnsignedIntQtQueryPipe::update(unsigned int newUnsignedInt) {
-  (*content) = newUnsignedInt;
+  content.set(newUnsignedInt);
   dialog->update();
 }
Index: src/UIElements/Qt4/Pipe/UnsignedIntQtQueryPipe.hpp
===================================================================
--- src/UIElements/Qt4/Pipe/UnsignedIntQtQueryPipe.hpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/UnsignedIntQtQueryPipe.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -15,4 +15,5 @@
 
 
+#include "Parameters/Parameter.hpp"
 #include <Qt/qwidget.h>
 
@@ -22,5 +23,5 @@
   Q_OBJECT
 public:
-  UnsignedIntQtQueryPipe(unsigned int *_content, QtDialog *_dialog);
+  UnsignedIntQtQueryPipe(Parameter<unsigned int> &_content, QtDialog *_dialog);
   virtual ~UnsignedIntQtQueryPipe();
 
@@ -29,5 +30,5 @@
 
 private:
-  unsigned int *content;
+  Parameter<unsigned int> &content;
   QtDialog *dialog;
 
Index: src/UIElements/Qt4/Pipe/VectorQtQueryPipe.cpp
===================================================================
--- src/UIElements/Qt4/Pipe/VectorQtQueryPipe.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/VectorQtQueryPipe.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -26,5 +26,5 @@
 
 
-VectorQtQueryPipe::VectorQtQueryPipe(Vector *_content, QtDialog *_dialog, QComboBox *_theBox) :
+VectorQtQueryPipe::VectorQtQueryPipe(Parameter<Vector> &_content, QtDialog *_dialog, QComboBox *_theBox) :
   content(_content),
   dialog(_dialog),
@@ -36,15 +36,21 @@
 
 void VectorQtQueryPipe::updateX(double newDouble) {
-  (*content)[0] = newDouble;
+  Vector v = content.get();
+  v[0] = newDouble;
+  content.set(v);
   dialog->update();
 }
 
 void VectorQtQueryPipe::updateY(double newDouble) {
-  (*content)[1] = newDouble;
+  Vector v = content.get();
+  v[1] = newDouble;
+  content.set(v);
   dialog->update();
 }
 
 void VectorQtQueryPipe::updateZ(double newDouble) {
-  (*content)[2] = newDouble;
+  Vector v = content.get();
+  v[2] = newDouble;
+  content.set(v);
   dialog->update();
 }
Index: src/UIElements/Qt4/Pipe/VectorQtQueryPipe.hpp
===================================================================
--- src/UIElements/Qt4/Pipe/VectorQtQueryPipe.hpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/VectorQtQueryPipe.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -15,4 +15,5 @@
 
 
+#include "Parameters/Parameter.hpp"
 #include <Qt/qwidget.h>
 
@@ -25,5 +26,5 @@
   Q_OBJECT
 public:
-  VectorQtQueryPipe(Vector *_content, QtDialog *_dialog, QComboBox *_theBox);
+  VectorQtQueryPipe(Parameter<Vector> &_content, QtDialog *_dialog, QComboBox *_theBox);
   virtual ~VectorQtQueryPipe();
 
@@ -34,5 +35,5 @@
 
 private:
-  Vector *content;
+  Parameter<Vector> &content;
   QtDialog *dialog;
   QComboBox *theBox;
Index: src/UIElements/Qt4/Pipe/VectorsQtQueryPipe.cpp
===================================================================
--- src/UIElements/Qt4/Pipe/VectorsQtQueryPipe.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/VectorsQtQueryPipe.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -28,5 +28,5 @@
 
 
-VectorsQtQueryPipe::VectorsQtQueryPipe(std::vector<Vector> *_content, QtDialog *_dialog, QComboBox *_theBox) :
+VectorsQtQueryPipe::VectorsQtQueryPipe(Parameter<std::vector<Vector> > &_content, QtDialog *_dialog, QComboBox *_theBox) :
   content(_content),
   dialog(_dialog),
Index: src/UIElements/Qt4/Pipe/VectorsQtQueryPipe.hpp
===================================================================
--- src/UIElements/Qt4/Pipe/VectorsQtQueryPipe.hpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Pipe/VectorsQtQueryPipe.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -15,4 +15,5 @@
 
 
+#include "Parameters/Parameter.hpp"
 #include <Qt/qwidget.h>
 
@@ -27,5 +28,5 @@
   Q_OBJECT
 public:
-  VectorsQtQueryPipe(std::vector<Vector>*_content, QtDialog *_dialog, QComboBox *_theBox);
+  VectorsQtQueryPipe(Parameter<std::vector<Vector> > &_content, QtDialog *_dialog, QComboBox *_theBox);
   virtual ~VectorsQtQueryPipe();
 
@@ -34,5 +35,5 @@
 
 private:
-  std::vector<Vector> *content;
+  Parameter<std::vector<Vector> > &content;
   QtDialog *dialog;
   QComboBox *theBox;
Index: src/UIElements/Qt4/QtDialog.cpp
===================================================================
--- src/UIElements/Qt4/QtDialog.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/QtDialog.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -80,107 +80,107 @@
 }
 
-void QtDialog::queryBoolean(const char* title,string)
+void QtDialog::queryBoolean(Parameter<bool> &param, const char* title,string)
 {
-  registerQuery(new BooleanQtQuery(title,inputLayout,this));
+  registerQuery(new BooleanQtQuery(param,title,inputLayout,this));
 }
 
-void QtDialog::queryAtom(const char* title, std::string)
+void QtDialog::queryAtom(Parameter<const atom *> &param, const char* title, std::string)
 {
-  registerQuery(new AtomQtQuery(title,inputLayout,this));
+  registerQuery(new AtomQtQuery(param,title,inputLayout,this));
 }
 
-void QtDialog::queryAtoms(const char* title, std::string)
+void QtDialog::queryAtoms(Parameter<std::vector<const atom *> > &param, const char* title, std::string)
 {
-  registerQuery(new AtomsQtQuery(title,inputLayout,this));
+  registerQuery(new AtomsQtQuery(param,title,inputLayout,this));
 }
 
-void QtDialog::queryBox(const char* title, std::string)
+void QtDialog::queryRealSpaceMatrix(Parameter<RealSpaceMatrix> &param, const char* title, std::string)
 {
-  registerQuery(new BoxQtQuery(title,inputLayout,this));
+  registerQuery(new RealSpaceMatrixQtQuery(param,title,inputLayout,this));
 }
 
-void QtDialog::queryInt(const char *title,string)
+void QtDialog::queryInt(Parameter<int> &param, const char *title,string)
 {
-  registerQuery(new IntQtQuery(title,inputLayout,this));
+  registerQuery(new IntQtQuery(param,title,inputLayout,this));
 }
 
-void QtDialog::queryInts(const char *title,string)
+void QtDialog::queryInts(Parameter<std::vector<int> > &param, const char *title,string)
 {
-  registerQuery(new IntsQtQuery(title,inputLayout,this));
+  registerQuery(new IntsQtQuery(param,title,inputLayout,this));
 }
 
-void QtDialog::queryUnsignedInt(const char *title,string)
+void QtDialog::queryUnsignedInt(Parameter<unsigned int> &param, const char *title,string)
 {
-  registerQuery(new UnsignedIntQtQuery(title,inputLayout,this));
+  registerQuery(new UnsignedIntQtQuery(param,title,inputLayout,this));
 }
 
-void QtDialog::queryUnsignedInts(const char *title,string)
+void QtDialog::queryUnsignedInts(Parameter<std::vector<unsigned int> > &param, const char *title,string)
 {
-  registerQuery(new UnsignedIntsQtQuery(title,inputLayout,this));
+  registerQuery(new UnsignedIntsQtQuery(param,title,inputLayout,this));
 }
 
-void QtDialog::queryDouble(const char* title,string)
+void QtDialog::queryDouble(Parameter<double> &param, const char* title,string)
 {
-  registerQuery(new DoubleQtQuery(title,inputLayout,this));
+  registerQuery(new DoubleQtQuery(param,title,inputLayout,this));
 }
 
-void QtDialog::queryDoubles(const char* title,string)
+void QtDialog::queryDoubles(Parameter<std::vector<double> > &param, const char* title,string)
 {
-  registerQuery(new DoublesQtQuery(title,inputLayout,this));
+  registerQuery(new DoublesQtQuery(param,title,inputLayout,this));
 }
 
-void QtDialog::queryString(const char* title,string)
+void QtDialog::queryString(Parameter<std::string> &param, const char* title,string)
 {
-  registerQuery(new StringQtQuery(title,inputLayout,this));
+  registerQuery(new StringQtQuery(param,title,inputLayout,this));
 }
 
-void QtDialog::queryStrings(const char* title,string)
+void QtDialog::queryStrings(Parameter<std::vector<std::string> > &param, const char* title,string)
 {
-  registerQuery(new StringsQtQuery(title,inputLayout,this));
+  registerQuery(new StringsQtQuery(param, title,inputLayout,this));
 }
 
-void QtDialog::queryMolecule(const char *title,string)
+void QtDialog::queryMolecule(Parameter<const molecule *> &param, const char *title,string)
 {
-  registerQuery(new MoleculeQtQuery(title,inputLayout,this));
+  registerQuery(new MoleculeQtQuery(param,title,inputLayout,this));
 }
 
-void QtDialog::queryMolecules(const char *title,string)
+void QtDialog::queryMolecules(Parameter<std::vector<const molecule *> > &param, const char *title,string)
 {
-  registerQuery(new MoleculesQtQuery(title,inputLayout,this));
+  registerQuery(new MoleculesQtQuery(param, title,inputLayout,this));
 }
 
-void QtDialog::queryVector(const char* title, bool check,string)
+void QtDialog::queryVector(Parameter<Vector> &param, const char* title, bool check,string)
 {
-  registerQuery(new VectorQtQuery(title,check,inputLayout,this));
+  registerQuery(new VectorQtQuery(param,title,check,inputLayout,this));
 }
 
-void QtDialog::queryVectors(const char* title, bool check,string)
+void QtDialog::queryVectors(Parameter<std::vector<Vector> > &param, const char* title, bool check,string)
 {
-  registerQuery(new VectorsQtQuery(title,check,inputLayout,this));
+  registerQuery(new VectorsQtQuery(param, title,check,inputLayout,this));
 }
 
-void QtDialog::queryElement(const char* title, std::string)
+void QtDialog::queryElement(Parameter<const element *> &param, const char* title, std::string)
 {
-  registerQuery(new ElementQtQuery(title,inputLayout,this));
+  registerQuery(new ElementQtQuery(param,title,inputLayout,this));
 }
 
-void QtDialog::queryElements(const char* title, std::string)
+void QtDialog::queryElements(Parameter<std::vector<const element *> > &param, const char* title, std::string)
 {
-  registerQuery(new ElementsQtQuery(title,inputLayout,this));
+  registerQuery(new ElementsQtQuery(param,title,inputLayout,this));
 }
 
-void QtDialog::queryFile(const char* title, std::string)
+void QtDialog::queryFile(Parameter<boost::filesystem::path> &param, const char* title, std::string)
 {
-  registerQuery(new FileQtQuery(title,inputLayout,this));
+  registerQuery(new FileQtQuery(param,title,inputLayout,this));
 }
 
-void QtDialog::queryFiles(const char* title, std::string)
+void QtDialog::queryFiles(Parameter<std::vector< boost::filesystem::path> >&param, const char* title, std::string)
 {
-  registerQuery(new FilesQtQuery(title,inputLayout,this));
+  registerQuery(new FilesQtQuery(param, title,inputLayout,this));
 }
 
-void QtDialog::queryRandomNumberDistribution_Parameters(const char* title, std::string)
+void QtDialog::queryRandomNumberDistribution_Parameters(Parameter<RandomNumberDistribution_Parameters> &param, const char* title, std::string)
 {
-  registerQuery(new RandomNumberDistribution_ParametersQtQuery(title,inputLayout,this));
+  registerQuery(new RandomNumberDistribution_ParametersQtQuery(param,title,inputLayout,this));
 }
 
Index: src/UIElements/Qt4/QtDialog.hpp
===================================================================
--- src/UIElements/Qt4/QtDialog.hpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/QtDialog.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -15,4 +15,5 @@
 
 
+#include "Parameters/Parameter.hpp"
 #include "UIElements/Dialog.hpp"
 #include <QtGui/QDialog>
@@ -33,25 +34,25 @@
 
   virtual void queryEmpty(const char*, std::string);
-  virtual void queryBoolean(const char *, std::string = "");
-  virtual void queryInt(const char *,std::string = "");
-  virtual void queryInts(const char *,std::string = "");
-  virtual void queryUnsignedInt(const char *,std::string = "");
-  virtual void queryUnsignedInts(const char *,std::string = "");
-  virtual void queryDouble(const char*,std::string = "");
-  virtual void queryDoubles(const char*,std::string = "");
-  virtual void queryString(const char*,std::string = "");
-  virtual void queryStrings(const char*,std::string = "");
-  virtual void queryAtom(const char*,std::string = "");
-  virtual void queryAtoms(const char*,std::string = "");
-  virtual void queryMolecule(const char*,std::string = "");
-  virtual void queryMolecules(const char*,std::string = "");
-  virtual void queryVector(const char*,bool,std::string = "");
-  virtual void queryVectors(const char*,bool,std::string = "");
-  virtual void queryBox(const char*, std::string = "");
-  virtual void queryElement(const char*,std::string = "");
-  virtual void queryElements(const char*,std::string = "");
-  virtual void queryFile(const char*,std::string = "");
-  virtual void queryFiles(const char*,std::string = "");
-  virtual void queryRandomNumberDistribution_Parameters(const char*,std::string = "");
+  virtual void queryBoolean(Parameter<bool> &, const char *, std::string = "");
+  virtual void queryInt(Parameter<int> &, const char *,std::string = "");
+  virtual void queryInts(Parameter<std::vector<int> > &, const char *,std::string = "");
+  virtual void queryUnsignedInt(Parameter<unsigned int> &, const char *,std::string = "");
+  virtual void queryUnsignedInts(Parameter<std::vector<unsigned int> > &, const char *,std::string = "");
+  virtual void queryDouble(Parameter<double> &, const char*,std::string = "");
+  virtual void queryDoubles(Parameter<std::vector<double> > &, const char*,std::string = "");
+  virtual void queryString(Parameter<std::string> &, const char*,std::string = "");
+  virtual void queryStrings(Parameter<std::vector<std::string> > &, const char*,std::string = "");
+  virtual void queryAtom(Parameter<const atom *> &, const char*,std::string = "");
+  virtual void queryAtoms(Parameter<std::vector<const atom *> > &, const char*,std::string = "");
+  virtual void queryMolecule(Parameter<const molecule *> &, const char*,std::string = "");
+  virtual void queryMolecules(Parameter<std::vector<const molecule *> > &, const char*,std::string = "");
+  virtual void queryVector(Parameter<Vector> &, const char*,bool,std::string = "");
+  virtual void queryVectors(Parameter<std::vector<Vector> > &, const char*,bool,std::string = "");
+  virtual void queryRealSpaceMatrix(Parameter<RealSpaceMatrix> &, const char*, std::string = "");
+  virtual void queryElement(Parameter<const element *> &, const char*,std::string = "");
+  virtual void queryElements(Parameter<std::vector<const element *> > &, const char*,std::string = "");
+  virtual void queryFile(Parameter<boost::filesystem::path> &, const char*,std::string = "");
+  virtual void queryFiles(Parameter<std::vector< boost::filesystem::path> > &, const char*,std::string = "");
+  virtual void queryRandomNumberDistribution_Parameters(Parameter<RandomNumberDistribution_Parameters> &, const char*,std::string = "");
 
   virtual bool display();
@@ -63,5 +64,5 @@
   class AtomsQtQuery;
   class BooleanQtQuery;
-  class BoxQtQuery;
+  class RealSpaceMatrixQtQuery;
   class DoubleQtQuery;
   class DoublesQtQuery;
Index: src/UIElements/Qt4/Query/AtomQtQuery.cpp
===================================================================
--- src/UIElements/Qt4/Query/AtomQtQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Query/AtomQtQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -30,6 +30,6 @@
 #include "World.hpp"
 
-QtDialog::AtomQtQuery::AtomQtQuery(std::string _title,QBoxLayout *_parent,QtDialog *_dialog) :
-    Dialog::AtomQuery(_title),
+QtDialog::AtomQtQuery::AtomQtQuery(Parameter<const atom *> &param, std::string _title,QBoxLayout *_parent,QtDialog *_dialog) :
+    Dialog::AtomQuery(param, _title),
     parent(_parent)
 {
@@ -46,5 +46,5 @@
   thisLayout->addWidget(inputBox);
 
-  pipe = new AtomQtQueryPipe(&tmp,_dialog, inputBox);
+  pipe = new AtomQtQueryPipe(tmp,_dialog, inputBox);
   pipe->update(inputBox->currentIndex());
   connect(inputBox,SIGNAL(currentIndexChanged(int)),pipe,SLOT(update(int)));
Index: src/UIElements/Qt4/Query/AtomsQtQuery.cpp
===================================================================
--- src/UIElements/Qt4/Query/AtomsQtQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Query/AtomsQtQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -33,6 +33,6 @@
 
 
-QtDialog::AtomsQtQuery::AtomsQtQuery(std::string _title,QBoxLayout *_parent,QtDialog *_dialog) :
-    Dialog::AtomsQuery(_title),
+QtDialog::AtomsQtQuery::AtomsQtQuery(Parameter<std::vector<const atom *> > &param, std::string _title,QBoxLayout *_parent,QtDialog *_dialog) :
+    Dialog::AtomsQuery(param, _title),
     parent(_parent)
 {
@@ -67,5 +67,5 @@
   thisHLayout->addLayout(thisV2Layout);
 
-  pipe = new AtomsQtQueryPipe(&tmp,_dialog,inputList);
+  pipe = new AtomsQtQueryPipe(tmp,_dialog,inputList);
   connect(inputList,SIGNAL(itemSelectionChanged()),pipe,SLOT(IntegerSelected()));
   connect(AddButton,SIGNAL(Clicked()),pipe,SLOT(add()));
Index: src/UIElements/Qt4/Query/BooleanQtQuery.cpp
===================================================================
--- src/UIElements/Qt4/Query/BooleanQtQuery.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/UIElements/Qt4/Query/BooleanQtQuery.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -28,11 +28,14 @@
 
 
-QtDialog::BooleanQtQuery::BooleanQtQuery(std::string _title, QBoxLayout *_parent, QtDialog *_dialog) :
-    Dialog::BooleanQuery(_title),
+QtDialog::BooleanQtQuery::BooleanQtQuery(Parameter<bool> &param, std::string _title, QBoxLayout *_parent, QtDialog *_dialog) :
+    Dialog::BooleanQuery(param, _title),
     parent(_parent)
 {
+  if (!param.isSet())
+    param.set(false);
   thisLayout = new QHBoxLayout();
   titleLabel = new QLabel(QString(getTitle().c_str()),_dialog);
   booleanCheckBox = new QCheckBox(QString(getTitle().c_str()), _dialog);
+  booleanCheckBox->setCheckState(param.get() ? Qt::Checked : Qt::Unchecked);
 
   parent->addLayout(thisLayout);
@@ -40,5 +43,5 @@
   thisLayout->addWidget(booleanCheckBox);
 
-  pipe = new BooleanQtQueryPipe(&tmp,_dialog,booleanCheckBox);
+  pipe = new BooleanQtQueryPipe(tmp,_dialog,booleanCheckBox);
   connect(booleanCheckBox, SIGNAL(stateChanged(int)), pipe, SLOT(update(int)));
 }
